// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/Shader.hpp"
#include "SimpleTexturedShaderProgram.hpp"
#include "scene/components/display/material/SimpleTexturedMaterial.hpp"

namespace Dawn {
  class SimpleTexturedShader : public Shader {
    protected:
      SimpleTexturedShaderProgram program;

    public:
      void compile() override;

      std::vector<struct ShaderPass> getItemPasses(
        MeshRenderer *mesh, Material *material
      ) override;

      void setGlobalParameters(
        glm::mat4 cameraProjection, glm::mat4 cameraView
      ) override;
  };
}